<?php
/*
Copyright (C) 2009  VideoWhisper.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

class RoomsModelRooms extends JModel
{


    /**
     * Hellos data array
     *
     * @var array
     */
    var $_data;

    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQuery()
    {
        $query = ' SELECT * '
            . ' FROM #__vw_rooms '
        ;
        return $query;
    }

    /**
     * Retrieves the hello data
     * @return array Array of objects containing the data from the database
     */
    function getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {

		// First update it
		$db =& JFactory::getDBO();
		$ztime=time();

	//room cleanups
	$ztime=time();
	$query = "UPDATE #__vw_rooms SET timelastaccess=timecreated where timelastaccess=0";
	$db->setQuery( $query );
  	$db->query();

	$query = "DELETE FROM #__vw_rooms WHERE (( timeexpire > 0) AND ((timeexpire*86400 + timecreated) < $ztime)) OR ((timeout > 0) AND ( ($ztime-timelastaccess) > (timeout * 3600)))";
    $db->setQuery( $query );
  	$db->query();

		//credit reset
		$query = "UPDATE #__vw_rooms SET creditslastreset=$ztime, timeused=0 WHERE (creditsreset > 0) AND (( $ztime - creditslastreset) > (creditsreset *86400))";
		$db->setQuery( $query );
		$db->query();

            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query );
        }

        return $this->_data;
    }



}
